-------------------------------------------------------------------------------------
-- HiAsm.ms
-- Export in project HiAsm (.sha format file)
-- HiAsm.com
-- Version 1.0 
-- author: sla8a
-- mail: sla8a@tut.by
-- 2013
-------------------------------------------------------------------------------------
utility HiAsmExport "HiAsm"
(
	local shaFile, tabs = ""
	checkbox cb_select_only "Selected Only"
	group "Window"
	(
	edittext ed_caption "Caption:" text:"OpenGL"
	colorpicker cl_background "Background:" color: [0,0,0] fieldWidth:22
	checkbox cb_fullscreen "FullScreen" tooltip:"Windows fullscreen" --checked:true
    spinner sp_width "Width:" range:[128,2048,800] type:#Integer align:#center--  enabled:false
	spinner sp_height "Height:" range:[128,2048,600] type:#Integer align:#center--  enabled:false
	)
	group "Scheme"
	(
	checkbox cb_showfps "Show FPS" checked:true
	checkbox cb_insertname "Insert Name" checked:true
	--checkbox cb_rotatescale "Rotate and scale" checked:true 
	)	
	button btn_export "Save as.." width:100
	button btn_about "About" width:100
-----------------------------------------------------------------------------------------
	function ExportTarget obj =
	(
		Format (tabs+"myobj.target = Targetobject()\n") to:shaFile
		Format (tabs+"myobj.target.name = \"%\"\n") obj.target.name to:shaFile
		Format (tabs+"myobj.target.transform = %\n") obj.target.transform to:shaFile
		Format (tabs+"myobj.target.position += createPos\n") to:shaFile
	)
-----------------------------------------------------------------------------------------
	function ExportGeneric obj =
	(
		Format (tabs+"%\n") (ClassOf obj) to:shaFile

		for prop in GetPropNames obj do
		(
			local propname = prop as String
			local propval  = GetProperty obj prop
			if (ClassOf obj) == Hedra and prop == #vertices then continue
			if propval != undefined then
				Format (tabs+"\t% %\n") propname propval to:shaFile
		)
		if obj.target != undefined then
			ExportTarget obj
		Format (tabs+"end %\n") (ClassOf obj) to:shaFile
	)
-----------------------------------------------------------------------------------------
	function ExportMesh meshObj ind =
	(
		i = ind  * 20 + 100
		Format "Add(MultiElementEx,%,%,266)\n{\n" (i)(287 + ind  * 40) to:shaFile
		if  cb_insertname.checked then
			Format " @Hint=#%:%|\n" (meshObj.name.count)(meshObj.name) to:shaFile
		Format " link(onDraw,%:doDraw,[]\n}\n" (i+20) to:shaFile
		Format "BEGIN_SDK\n" to:shaFile
		Format "  Add(EditMultiEx,%,21,21)\n  {\n   WorkCount=#6:doDraw|\n" (i + 1) to:shaFile
		Format "   EventCount=#6:onDraw|\n   Width=384\n   Height=235\n" to: shaFile
		Format "   link(doDraw,%:doBegin,[(53,27)(53,111)])\n  }\n" (i + 2) to:shaFile
		Format "  Add(Gl_Begin,%,84,105)\n  {\n   BlockType=4\n   link(onBegin,%:doEnum,[])\n  }\n" (i + 2)(i + 6) to:shaFile
		Format "  Add(Gl_End,%,175,210)\n  {\n   link(onEnd,%:onDraw,[(368,216)(368,27)])\n  }\n" (i + 3)(i + 1) to:shaFile
		Format "  Add(GL_Vertex3D,%,259,161)\n  {\n" (i + 4) to:shaFile
		Format "   link(X,%:Part4,[(265,152)(244,152)])\n" (i + 5) to:shaFile
		Format "   link(Y,%:Part5,[(272,149)(251,149)])\n" (i + 5) to:shaFile
		Format "   link(Z,%:Part6,[(279,144)(258,144)])\n  }\n" (i + 5) to:shaFile
		Format "  Add(MultiStrPart,%,217,105)\n  {\n   Count=6\n" (i + 5) to:shaFile
		Format "   link(onSplit,%:doNormal,[(300,111)(300,199)(205,199)(205,167)])\n  }\n" (i + 8) to:shaFile
		Format "  Add(ArrayEnum,%,126,105)\n  {\n" (i + 6) to:shaFile
		Format "   link(onItem,%:doRead,[])\n" (i + 7) to:shaFile
		Format "   link(onEndEnum,%:doEnd,[(166,118)(166,216)])\n" (i + 3) to:shaFile
		Format "   link(Array,%:Array,[])\n  }\n" (i + 9) to:shaFile
		Format "  Add(ArrayRW,%,175,105)\n  {\n" (i + 7) to:shaFile
		Format "   link(onRead,%:doSplit,[])\n" (i + 5) to:shaFile
		Format "   link(Array,%:Array,[])\n  }\n" (i + 10) to:shaFile
		Format "  Add(GL_Normal,%,217,161)\n  {\n" (i + 8) to:shaFile
		Format "   link(onNormal,%:doVertex,[])\n" (i + 4) to:shaFile
		Format "   link(X,%:Part1,[])\n" (i + 5) to:shaFile
		Format "   link(Y,%:Part2,[])\n" (i + 5) to:shaFile
		Format "   link(Z,%:Part3,[])\n  }\n" (i + 5) to:shaFile
		-- Write faces
		if meshObj.numFaces > 0 then
		(
			Format"Add(StrList,%,112,49)\n{\n Strings=#" (i+9) to:shaFile	
			for i = 1 to meshObj.numFaces do
            (
				str = ((GetFace meshObj i).x as integer - 1) as string
				Format(tabs+"%:%|")(str.count)(str) to:shaFile
				str = ((GetFace meshObj i).y as integer - 1) as string
				Format(tabs+"%:%|")(str.count)(str) to:shaFile
				str = ((GetFace meshObj i).z as integer - 1) as string	
				Format(tabs+"%:%|")(str.count)(str) to:shaFile
			)
			Format"\n}\n" to:shaFile
		)	
		-- Write vertices
		if meshObj.numVerts > 0 then
		(
			Format"Add(StrList,%,161,49)\n{\n Strings=#" (i + 10) to:shaFile	
			for i = 1 to meshObj.numVerts do
			(
				str = (GetNormal meshObj i).x as string +";"+
						(GetNormal meshObj i).y as string +";"+
						(GetNormal meshObj i).z as string +";"+ 
						((GetVert meshObj i).x - meshObj.Center.x - meshObj.position.x) as string +";"+
						((GetVert meshObj i).z - meshObj.Center.z - meshObj.position.z) as string +";"+
						((GetVert meshObj i).y - meshObj.Center.y - meshObj.position.y) as string	
				Format(tabs+"%:%|")(str.count)(str) to:shaFile
			)
			Format"\n}\n" to:shaFile
		)
		Format "END_SDK\n" to:shaFile
	)
-----------------------------------------------------------------------------------------
	function ExportTexVertices MeshObj =
	(
		-- Write texture vertices
		if MeshObj.numTVerts > 0 then
		(
			for i = 1 to meshObj.NumTVerts do
			(
				Format (tabs+"\t% % %\n") (GetTVert meshObj i).x (GetTVert meshObj i).y (GetTVert meshObj i).z to:shaFile
			)
		)
		-- Write texture faces
		if meshObj.numfaces > 0 then
		(
			for i = 1 to meshObj.numfaces do
			(
				Format (tabs+"\t% % %\n") ((GetTVFace meshObj i).x as Integer) ((GetTVFace meshObj i).y as Integer) ((GetTVFace meshObj i).z as Integer) to:shaFile
			)
		)
	)
-----------------------------------------------------------------------------------------
	function ExportNode node ind =
	(
		if SuperClassOf node == GeometryClass and ClassOf node == Editable_mesh then
			ExportMesh node ind
		else if (not (ClassOf node == Targetobject and node.isTarget)) then
			ExportGeneric node
		else
			return false
		return true
	)
	-------------------------------------------------------------------------------------
	function RecursiveExportNode node ind =
	(
		if (ExportNode node ind) == false then return false
		-- Recurse children before writing this node
		for child in node.children do RecursiveExportNode child ind
	)

-----------------------------------------------------------------------------------------
	function GetSaveFileStream =
	(
		fname = GetSaveFileName types:"Project HiAsm (*.sha)|*.sha|All Files(*.*)|*.*|"
		if fname == undefined then
			return undefined
		shaFile = CreateFile fname
		if shaFile == undefined then
		(
			MessageBox "Couldn't open file for writing" title:"Error" beep:false
			return undefined
		)
		return shaFile
	)
-----------------------------------------------------------------------------------------
	on  cb_fullscreen changed check do
	(
		if cb_fullscreen.checked then
		(  
			sp_width.enabled = false
			sp_height.enabled = false
		)
		else
		(
			sp_width.enabled = true
			sp_height.enabled = true
		)
	)
-----------------------------------------------------------------------------------------
	on btn_export pressed do
	(
		shaFile = GetSaveFileStream()
		if shaFile != undefined then
		(
			Format "*author:#13#10make in 3Ds max:\nMake(delphi)\nver(4.04 build 185)\n"	to:shaFile
			if cb_showfps.checked then
			(	
				Format "Add(FormatStr,10712340,175,49)\n{\n DataCount=1\n Mask=\"%(FPS: \%1)\"\n link(onFString,2953706:doCaption,[])\n link(Str1,8821841:Var,[])\n}\n"(ed_caption.text) to:shaFile
				Format "Add(LineBreak,8746168,189,182)\n{\n Caption=\"fps\"\n Type=1\n link(Data,15626728:Fps,[])\n Primary=[8821841,-14,-161]\n}\n" to:shaFile
				countHubEvents = 3
				captionForm = ""
			)
			else
			(	
				countHubEvents = 2
				captionForm = " Caption=" + ed_caption.text + "\n"
			)
			Format "Add(Hub,9875206,98,168)\n{\n OutCount=%\n link(onEvent1,7054645:doClear,[(119,174)(119,279)])\n link(onEvent2,7337176:doPopMatrix,[])\n" (countHubEvents) to:shaFile
			if cb_showfps.checked then Format " link(onEvent3,10712340:doString,[(125,188)(125,55)])\n}\n" to:shaFile
			else  Format"}\n" to:shaFile
			-- MainForm
			Format "Add(MainForm,2953706,217,49)\n{\n%" (captionForm)	to:shaFile
			if cb_fullscreen.checked then  Format "  BorderStyle=0\n  WindowsState=2\n" to:shaFile
			else Format " Width=%\n Height=%\n Position=1\n" (sp_width.value  as string) (sp_height.value  as string) to:shaFile
			Format " Point(Handle)\n Point(onMouseDown)\n Point(onMouseMove)\n Point(onMouseWheel)\n Point(onResize)\n" to:shaFile
			Format " Point(Width)\n Point(SizeHeader)\n Point(Height)\n Point(MouseX)\n Point(MouseY)\n" to:shaFile
			Format " link(onCreate,15733578:doEvent1,[(285,69)(285,12)(19,12)(19,146)])\n link(onMouseDown,14861296:Wire1,[])\n" to:shaFile
			Format " link(onMouseMove,14861296:Wire2,[])\n link(onMouseWheel,14861296:Wire3,[])\n link(onResize,7259617:doWork1,[(273,97)(273,129)(165,129)])\n" to:shaFile
			Format "Add(GL_Main,15626728,182,140)\n{\n Color=%\n" ((cl_background.color.r + bit.shift cl_background.color.g 8 + bit.shift cl_background.color.b 16) as integer)to:shaFile
			Format " Point(Fps)\n link(onInit,12198675:doInit,[])\n link(onViewPort,12770313:doCalc,[])\n" to:shaFile
			Format " link(Handle,2953706:Handle,[(188,115)(223,115)])\n}\n" to:shaFile
			Format "Add(GL_Perspective,1242625,266,147)\n{\n Aspect=0\n Fovy=25\n zFar=60\n}\n" to:shaFile
			Format "Add(GL_GluTools,12198675,308,140)\n{\n Texture=0\n link(onInit,5809249:doEnabled,[])\n}\n" to:shaFile
			Format "Add(GL_Options,5809249,350,140)\n{\n Flag=2\n link(onEvent,3551206:doEnabled,[])\n}\n" to:shaFile
			Format "Add(Timer,8025317,56,168)\n{\n Interval=33\n Enable=1\n link(onTimer,9875206:doEvent1,[])\n}\n" to:shaFile
			Format "Add(Hub,15733578,28,140)\n{\n OutCount=3\n link(onEvent1,15626728:doInit,[])\n link(onEvent2,7259617:doWork2,[])\n" to:shaFile
			Format " link(onEvent3,8025317:doTimer,[(49,160)(49,174)])\n}\n" to:shaFile
			Format "Add(GL_GTools,7054645,154,273)\n{\n @Hint=#1:X|\n ClearStencil=1\n Point(doClear)\n link(onEvent,8470228:doPushMatrix,[])\n AddHint(-1,-21,22,13,@Hint)\n}\n" to:shaFile
			Format "Add(GL_GTools,8470228,196,273)\n{\n @Hint=#2:\/|\n ClearStencil=1\n Point(doPushMatrix)\n link(onEvent,1916906:doTransform,[])\n AddHint(-2,-20,25,13,@Hint)\n}\n" to:shaFile
			Format "Add(GL_GTools,7337176,133,175)\n{\n @Hint=#2:/\|\n ClearStencil=1\n Point(doPopMatrix)\n link(onEvent,15626728:doFlip,[(173,181)(173,160)])\n" to:shaFile
			Format " AddHint(-3,-18,25,13,@Hint)\n}\n" to:shaFile
			Format "Add(CableData,16583616,245,112)\n{\n link(Wire1,2953706:MouseX,[])\n link(Wire2,2953706:MouseY,[])\n}\n" to:shaFile
			Format "Add(CableWork,14861296,273,70)\n{\n Count=3\n link(Cable,5628864:In,[])\n}\n" to:shaFile
			Format "Add(GL_Light,14989894,476,140)\n{\n Diffuse=12632256\n Specular=8421504\n link(onEnabled,14989894:doMove,[(515,146)(515,180)(472,180)(472,153)])\n" to:shaFile
			Format " link(Point,4869358:Point3D,[])\n}\n" to:shaFile
			Format "Add(GL_Options,3551206,392,140)\n{\n Flag=3\n link(onEvent,13309583:doEnabled,[])\n}\n" to:shaFile
			Format "Add(GL_Point3D,4869358,476,98)\n{\n X=12\n Y=12\n Z=20\n}\n" to:shaFile
			Format "Add(GL_Options,13309583,434,140)\n{\n link(onEvent,14989894:doEnabled,[])\n}\n" to:shaFile
			Format "Add(MathParse,12770313,224,147)\n{\n DataCount=3\n MathStr=\"\%1 / (\%2 - \%3)\"\n link(onResult,1242625:doPerspective,[])\n link(X1,2953706:Width,[])\n" to:shaFile
			Format " link(X2,2953706:SizeHeader,[])\n link(X3,2953706:Height,[])\n}\n" to:shaFile
			Format "Add(HubEx,7259617,161,147)\n{\n link(onEvent,15626728:doViewPort,[])\n}\n" to:shaFile
			Format "Add(LineBreak,862202,182,231)\n{\n Caption=\"mouse\"\n link(Out,1916906:doMouseMove,[(236,237)(236,272)])\n Primary=[5628864,119,-161]\n}\n" to:shaFile
			--Rotate And Scale
			Format "Add(MultiElementEx,1916906,245,266)\n{\n link(onTransform,100:doDraw,[])\n link(MouseXY1,16583616:Cable,[])\n}\n" to:shaFile
			Format "BEGIN_SDK\n" to:shaFile
			Format "  Add(EditMultiEx,16089950,21,21)\n  {\n   WorkCount=#11:doMouseMove|11:doTransform|\n   EventCount=#11:onTransform|\n   DataCount=#8:MouseXY1|\n   Width=895\n" to:shaFile
			Format "   Height=466\n   link(doMouseMove,7512112:Cable,[(53,27)(53,153)])\n   link(doTransform,6797271:doTranslate,[(33,34)(33,405)])\n  }\n" to:shaFile
			Format "  Add(IndexToChanel,7948326,119,217)\n  {\n   Count=3\n   link(onEvent1,2184267:doEvent1,[])\n   link(onEvent2,236993:doEvent1,[])\n" to:shaFile
			Format "   link(onEvent3,236993:doEvent2,[])\n  }\n" to:shaFile
			Format "  Add(Memory,3567546,504,154)\n  {\n  }\n" to:shaFile
			Format "  Add(Memory,12077570,413,154)\n  {\n   link(onData,6620054:doCalcDelta,[])\n  }\n" to:shaFile
			Format "  Add(GL_Rotate,12052872,406,399)\n  {\n   Y=1\n   link(onRotate,7584131:doRotate,[])\n   link(Angle,7668636:Var2,[])\n  }\n" to:shaFile
			Format "  Add(GL_Rotate,7584131,497,399)\n  {\n   X=1\n   link(onRotate,2757219:doScale,[])\n   link(Angle,12084249:Var2,[])\n  }\n" to:shaFile
			Format "  Add(CableVar,16443725,364,77)\n  {\n   link(Cable,16089950:MouseXY1,[(370,28)(27,28)])\n  }\n" to:shaFile
			Format "  Add(CableEvent,7512112,70,147)\n  {\n   Count=3\n   link(Wire1,8302275:doWork1,[(221,153)])\n   link(Wire2,7948326:doEvent,[(112,160)(112,223)])\n" to:shaFile
			Format "   link(Wire3,448642:doOperation,[(97,167)(97,279)])\n  }\n" to:shaFile
			Format "  Add(SampleDelta,10269547,364,154)\n  {\n   link(onCalcDelta,12077570:doValue,[])\n   link(Data,16443725:Wire1,[])\n  }\n" to:shaFile
			Format "  Add(SampleDelta,6620054,462,154)\n  {\n   link(onCalcDelta,3567546:doValue,[])\n   link(Data,16443725:Wire2,[(468,128)(377,128)])\n  }\n" to:shaFile
			Format "  Add(Math,14984929,406,224)\n  {\n   link(onResult,9748629:doOperation,[])\n   link(Op1,7668636:Var1,[(412,212)(403,212)(403,264)])\n" to:shaFile
			Format "   link(Op2,5866415:Var2,[])\n  }\n" to:shaFile
			Format "  Add(GetDataEx,7668636,406,259)\n  {\n   link(Data,14984929:Result,[])\n  }\n" to:shaFile
			Format "  Add(Math,9748629,497,224)\n  {\n   link(Op1,12084249:Var1,[(503,212)(494,212)(494,264)])\n   link(Op2,14569613:Var2,[])\n  }\n" to:shaFile
			Format "  Add(GetDataEx,12084249,497,259)\n  {\n   link(Data,9748629:Result,[])\n  }\n" to:shaFile
			Format "  Add(HubEx,8302275,217,154)\n  {\n   link(onEvent,10269547:doCalcDelta,[])\n  }\n" to:shaFile
			Format "  Add(Hub,2184267,196,217)\n  {\n   link(onEvent1,8302275:doWork3,[(221,223)])\n   link(onEvent2,14984929:doOperation,[])\n  }\n" to:shaFile
			Format "  Add(Gl_Translate,6797271,273,399)\n  {\n   Z=-22\n   link(onTranslate,12052872:doRotate,[])\n   link(X,10309471:Result,[])\n" to:shaFile
			Format "   link(Y,688423:Result,[(286,383)(363,383)])\n  }\n" to:shaFile
			Format "  Add(Math,3639241,231,336)\n  {\n   OpType=1\n   link(onResult,10309471:doOperation,[])\n   link(Op1,3639241:Result,[(237,324)(228,324)(228,376)(237,376)])\n" to:shaFile
			Format "   link(Op2,5866415:Var1,[(244,194)])\n  }\n" to:shaFile
			Format "  Add(Math,4448419,315,336)\n  {\n   OpType=1\n   link(onResult,688423:doOperation,[])\n   link(Op1,4448419:Result,[(321,324)(312,324)(312,376)(321,376)])\n" to:shaFile
			Format "   link(Op2,14569613:Var1,[(328,201)])\n  }\n" to:shaFile
			Format "  Add(Math,10309471,273,336)\n  {\n   OpType=3\n   Op2=100\n   link(onResult,4448419:doOperation,[])\n   AddHint(-16,-26,42,13,Op2)\n  }\n" to:shaFile
			Format "  Add(Math,688423,357,336)\n  {\n   OpType=3\n   Op2=100\n   AddHint(-10,-25,42,13,Op2)\n  }\n" to:shaFile
			Format "  Add(GetDataEx,5866415,413,189)\n  {\n   link(Data,12077570:Value,[])\n  }\n" to:shaFile
			Format "  Add(GetDataEx,14569613,504,196)\n  {\n   link(Data,3567546:Value,[])\n  }\n" to:shaFile
			Format "  Add(Hub,236993,161,224)\n  {\n   InCount=2\n   link(onEvent1,8302275:doWork2,[(186,230)(186,160)])\n" to:shaFile
			Format "   link(onEvent2,3639241:doOperation,[(187,237)(187,342)])\n  }\n" to:shaFile
			Format "  Add(Gl_Scale,2757219,595,399)\n  {\n   link(onScale,16089950:onTransform,[(829,405)(829,27)])\n   link(X,16450015:Var1,[(601,383)])\n" to:shaFile
			Format "   link(Y,16450015:Var2,[])\n   link(Z,16450015:Var3,[(615,383)])\n  }\n" to:shaFile
			Format "  Add(Math,448642,532,273)\n  {\n   OpType=3\n   Op2=10000\n   link(onResult,4063820:doOperation,[])\n  }\n" to:shaFile
			Format "  Add(GetDataEx,16450015,602,378)\n  {\n   link(Data,4800512:Var2,[])\n  }\n" to:shaFile
			Format "  Add(Math,4063820,602,273)\n  {\n   Default=0.1\n   Point(doDefault)\n   link(onResult,102260:doCompare,[])\n" to:shaFile
			Format "   link(Op1,4800512:Var1,[(608,261)(596,261)(596,317)])\n  }\n" to:shaFile
			Format "  Add(GetDataEx,4800512,602,312)\n  {\n   link(Data,4063820:Result,[])\n  }\n" to:shaFile
			Format "  Add(If_else,102260,644,273)\n  {\n   Type=3\n   Op2=Real(0)\n   link(onTrue,9242972:doData,[])\n   AddHint(-8,-24,30,13,Op2)\n  }\n" to:shaFile
			Format "  Add(DoData,9242972,693,273)\n  {\n   Data=Real(0.001)\n   link(onEventData,4063820:doDefault,[(737,279)(737,334)(580,334)(580,286)])\n" to:shaFile
			Format "   AddHint(-10,-31,42,13,Data)\n  }\n" to:shaFile
			Format "END_SDK\n" to:shaFile
			ind = 0
			if cb_select_only.checked then
				for node in selection do
				(
					ExportNode node ind
					ind += ind +1
				)
			else
				for node in rootnode.children do
				(
					RecursiveExportNode node ind
					ind += ind +1
				)
				--	for node in selection do
		--		(
		--                 if SuperClassOf node == GeometryClass and ClassOf node == Editable_mesh then
		--			(
		--			Format "New Texture:\n" to:shaFile
		--			ExportTexVertices node
		--			Format "end of texture\n"	to:shaFile
		--			)
		--		)
		--        Format "end of file" to:shaFile 
		--str = "Adadfasdfasdfasdfasdf"
		--setclipboardText str
		
		Close shaFile
		)
	)
-----------------------------------------------------------------------------------------
	on btn_about pressed do
	(
		MessageBox "Export in project HiAsm (.sha format file)\n\t  HiAsm.com\n\t   ----------\n\tauthor: sla8a\n\tsla8a@tut.by\n\t      2013" title:"About"
	) 
-----------------------------------------------------------------------------------------

) 
-- End HiAsmExport


